! Copyright 2010-2014 Lixin He, Kun Cao and Zhen Wang
! 
! This file is part of 3tangle
! 
! 3tangle is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
! 
! 3tangle is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
! 
! You should have received a copy of the GNU General Public License
! along with 3tangle.  If not, see <http://www.gnu.org/licenses/>.
! 
!the parameter of lattice
!!================================================================a=====
!	interger version of	RANDOM NUMBER GENERATOR in 32 bit computer system
!
!	we use the so-called minimal standard multiplicative linear congruential
!	generator, with is in the form of 																				   
!						z(n+1)=z(n)*a mod m
!	where 'm' is a primie modulus and 'a' a multiplier. {z(n)} is the random
!	number sequence. here we use m=2^31-1=2147483647, a=7^5=16807 and the 
!	portable arithmatic suggested by S.K.Park and K.W.Miller. Our code is 
!	written according to that by Vanderbilt et al written with Fortran, in 
!	which Bays-Durham shuffle and safeguards are added. Here z(1) is called 
!	the initial seed. 
!
!===================================================================== 
 module para
 implicit none
                           
            
 !the parameter for calculating accepting rate
 integer(kind=4)::totcount,totacpt
 integer(kind=4),parameter::countstep=1000000000
 double precision::totrate


 !distribution parameter

  double precision::deltaul=1.0,muul=0.0,deltaub=1.0,muub=0.0
!  double precision::pu=0.3,pl=0.2,beta0=2.0,beta1=2.0,probb,probl
  double precision::deltas=1.0,mus=0.0
  double precision::psmax=0.5,psmin=0.4,probs
  double precision,allocatable::sigma(:)
  integer(kind=4),allocatable::iac(:) 
  integer,parameter::adapflag=1

!################################### parameters of replica exchange #############################

!parameter of MPI
integer::nproc,my_rank
integer::ierr,itag
integer::seedx,seed_cau,seed_met
integer,allocatable::seed(:)

!parameters of replica exchange
integer::mybeta_num,bcast_rank
integer,parameter::sendsize=2,recvsize=2
double precision,allocatable::beta(:)
integer(kind=4),allocatable::exacpt(:)
integer(kind=4),allocatable::excount(:)
integer,allocatable::process(:)
integer,allocatable::betanum(:)
integer,allocatable::exbeta(:,:)
double precision,dimension(0:sendsize-1)::nsend,send_init,recv_init
double precision,dimension(0:recvsize-1)::nrecv
double precision,parameter::betamin=1.0d-2,betamax=1.0d6
!integer,parameter::nkap=1 !MAX times of updating kappa
integer,parameter::nscheme=2,nrec=30,srec=15
integer,parameter::nswp1=10,nexch1=5
integer,parameter::nswp2=10,nexch2=5
integer::nswp,nexch
integer,parameter::nequi1=10,nequi2=5
integer::ikap,irec,iswp,iexch,ischeme,ibeta,iequi,tarbeta1,tarbeta2
integer::exflag,exflag1,stat,irank
integer::betanum_temp,process_temp
 
!parameters of recursion
double precision::wk,wk_temp
double precision,allocatable::wb(:),wb_temp(:)
integer,parameter::initial_beta=0
!integer,parameter::proflag=0
!integer,parameter::initialsflag=0
!integer,parameter::initialuflag=0
integer,parameter::initial_bedis=0

!the value of constrained function, the equivalence of energy
double precision::tote
 end module
 
 
 
module minimum
!double precision,allocatable::x_min(:,:),r2_min(:),doe_min(:)
double precision,allocatable::fvec2_min1(:)
double precision::fvec2_min,r2_min,doe_min
double precision,allocatable::x_min(:)
double precision minlocin(2),minlocout(2)

end module

module common_doe
    
       double precision MATR(1000,1000), MATI(1000,1000) ! real and imag part of density matrix MAT
       double precision  kappa,gamma,eps0,dkappa   ! eps0: the critical value to stop updating kappa 
                                                   ! dkappa: the steplenth of updating kappa
       double precision,parameter::gauss=1.d0 
       integer NPAR, NLEV, NP, NC   ! number of particles, 
                                    ! number of single-particle levels
                                    ! number of partitions
                                    ! number of many-particle configurations 
       integer,parameter::doeflag=1
       character(len=3)::initialx='ran'
       double precision::dtemp=0.d0
       integer::kappaflag=0         !determine whether to stop updataing kappa
end module

!####################


!##########################################
!##############################################
