! Copyright 2010-2014 Lixin He, Kun Cao and Zhen Wang
! 
! This file is part of 3tangle
! 
! 3tangle is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
! 
! 3tangle is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
! 
! You should have received a copy of the GNU General Public License
! along with 3tangle.  If not, see <http://www.gnu.org/licenses/>.
! 
!  Purpose: The main program of the project
!
!============================================================

program replica_ex
   use para
   implicit none
   include 'mpif.h'

   integer::i
   integer status(MPI_STATUS_SIZE)
!  integer::one=1 !seems useless


   call MPI_INIT(ierr) !!MPI initializing
   call MPI_Comm_rank(MPI_COMM_WORLD,my_rank,ierr) !!set MPI ranks for each process
   call MPI_Comm_size(MPI_COMM_WORLD, nproc, ierr) !!set MPI sizes
        

!  write(*,*) 'my_rank =',my_rank
!  write(*,*) 'nproc =',nproc
   
!  generate the seed array used in different process
   call seed_gen
   
!  call MPI_BARRIER(MPI_COMM_WORLD,ierr)
   seed_met = seed(my_rank)
   seedx = seed_met-1234
   seed_cau=seedx
!  write(*,*) seed1

!  initialize the variable needed in the replica exchange
   call replica_init

!  the main recursion process
   call mixdoe
   
   call MPI_Finalize(ierr)
   
end program
