! Copyright 2010-2014 Lixin He, Kun Cao and Zhen Wang
! 
! This file is part of 3tangle
! 
! 3tangle is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
! 
! 3tangle is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
! 
! You should have received a copy of the GNU General Public License
! along with 3tangle.  If not, see <http://www.gnu.org/licenses/>.
! 
!  Purpose: Generate seed for each process
!
!====================================================

subroutine seed_gen
   use para
   implicit none
   include 'mpif.h'

   !variable declarations   
   double precision,external::ran1!the seed generator function
   integer::i,j   !used in loop
   integer::seed0=-2340
   !integer::testflag=0 !seems useless
   integer istatus(MPI_STATUS_SIZE)
   
   !open(300,file='test.dat')
   
   allocate(seed(0:nproc-1)) !each process has a seed
   do i=0,nproc-1
      seed(i)=int(-59370*ran1(seed0))
   end do
   
   do i=0,nproc-1 !check whether different processes have a same seed
      do j=0,nproc-1
         if(i/=j.and.seed(i)==seed(j))then
            write(*,*)'initial seed error'
         end if
      end do
   end do
    
end subroutine 
    
